indexing

   description: "Test Posix asynchronous io."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"

class 

   TEST_P_ASYNC_IO


inherit
   
   POSIX_CURRENT_PROCESS
   
   POSIX_FILE_SYSTEM

   POSIX_SYSTEM


creation
   
   make

   
feature
   
   make is
      local
         fd: POSIX_FILE_DESCRIPTOR
         request: POSIX_ASYNC_IO_REQUEST
      do
         print ("testing Posix asynchronous io.%N")

         if not supports_asynchronous_io then
            stderr.puts ("!! Asynchronous i/o not supported.%N")
            exit (1)
         end

         create fd.create_read_write ("berend.temp")
         create request.make (fd)
         request.set_offset (0)
         print ("Write something.%N")
         request.write_string ("hello world.")
         sleep (2)
         print ("Result: ")
         print (request.return_status)
         print ("%N")
         request.set_offset (6)
         request.set_count (5)
         print ("Read something.%N")
         request.read_string
         request.wait_for
         print ("Result: ")
         print (request.return_status)
         print ("%N")
         print ("Read: ")
         print (request.last_string)
         print ("%N")
         
         request.set_offset (12)
         request.write_string ("ABC")
         -- synchronize somehow removes write request?? 
         -- saw this behaviour with Linux 6.2 and 7.1         
         -- if you take a look at berend.temp you see zero's where ABC
         -- should have been.         
         --request.synchronize
         request.wait_for
         print ("Result: ")
         print (request.return_status)
         print ("%N")
         
         request.set_offset (15)
         request.write_string ("more text.")
         request.cancel
         if request.cancel_failed then
            print ("Operation could not be canceled anymore.%N")
         end
         request.wait_for
         sleep (2)
        
         fd.close
         
         -- remove_file ("berend.temp")
         
         print ("End of Posix asynchronous io.%N")
      end
   
end -- class TEST_P_ASYNC_IO
